<?php

/**
 * This Software is the property of Data Development and is protected
 * by copyright law - it is NOT Freeware.
 * Any unauthorized use of this software without a valid license
 * is a violation of the license agreement and will be prosecuted by
 * civil and criminal law.
 * http://www.shopmodule.com
 *
 * @copyright (C) D3 Data Development (Inh. Thomas Dartsch)
 * @author        D3 Data Development <support@shopmodule.com>
 * @link          http://www.oxidmodule.com
 */
class d3_oxorderarticle_printorder extends d3_oxorderarticle_printorder_parent{

    /**
     * Select lists for tpl
     *
     * @var array
     */
    protected $_aDispSelList;

    /**
     * Returns article thumbnail picture url
     *
     * @param bool $bSsl to force SSL
     *
     * @return string
     */
    public function getThumbnailUrl( $bSsl = null )
    {
        $sUrl = '';

        if (d3_cfg_mod::get('d3printorder')->isActive()) {

            $oArticle = oxNew('oxarticle');

            try {
                $oArticle->load($this->oxorderarticles__oxartid->value);
                $sUrl = $oArticle->getThumbnailUrl($bSsl);

            } catch (Exception $oE) {
                d3_cfg_mod::get('d3printorder')->d3getLog()->Log(
                    d3log::ERROR,
                    __CLASS__,
                    __FUNCTION__,
                    __LINE__,
                    'can not load article', //
                    'try to load oxarticle to get picture for printorder-email\n'
                    . PHP_EOL . PHP_EOL . $oE->getMessage()
                );
            }

        }

        return $sUrl;
    }

    /**
     * Sets selectlists of current product
     *
     * @param array $aSelList selectlist
     */
    public function setSelectlist($aSelList)
    {
        $this->_aDispSelList = $aSelList;
    }

    /**
     * Returns select lists to display
     *
     * @return array
     */
    public function getDispSelList()
    {
        if ($this->_aDispSelList === null) {
            if ($this->getConfig()->getConfigParam('bl_perfLoadSelectLists') && $this->getConfig()->getConfigParam('bl_perfLoadSelectListsInAList')) {
                $this->_aDispSelList = $this->getSelectLists();
            }
        }

        return $this->_aDispSelList;
    }

    /**
     * Returns article icon picture url. If no index specified, will
     * return main icon url.
     *
     * @param int $iIndex picture index
     *
     * @return string
     */
    public function getIconUrl($iIndex = 0)
    {
        $sUrl = '';

        if (d3_cfg_mod::get('d3printorder')->isActive()) {

            try {
                $oArticle = oxNew('oxarticle');
                $oArticle->load($this->oxorderarticles__oxartid->value);
                $sUrl = $oArticle->getIconUrl($iIndex);

            } catch (Exception $oE) {
                d3_cfg_mod::get('d3printorder')->d3getLog()->Log(
                    d3log::ERROR,
                    __CLASS__,
                    __FUNCTION__,
                    __LINE__,
                    'can not load article', //
                    'try to load oxarticle to get picture for printorder-email\n'
                    . PHP_EOL . PHP_EOL . $oE->getMessage()
                );
            }
        }

        return $sUrl;
    }
}
